package igntest

// Important note: functions in this module should not include
// references to parent package 'ign', to avoid circular dependencies.
// These functions should be independent.

import (
	"encoding/json"
	"github.com/stretchr/testify/assert"
	"net/http"
	"os"
	"regexp"
	"testing"
)

// Generic Router tests helper functions. To be invoked from
// projects that defines the routes.

// InvalidRouteTestHelper is a helper test function that just invokes
// an invalid route
func InvalidRouteTestHelper(t *testing.T) {
	uri := "/1.0/invalidroute/"
	myJWT := os.Getenv("IGN_TEST_JWT")
	AssertRouteMultipleArgs("GET", uri, nil, http.StatusNotFound, &myJWT, "text/plain; charset=utf-8", t)
	t.Log("InvalidRouteTestHelper run")
}

// OptionsTestHelper is a helper function to test the autogenerated OPTIONS
// urls, given a set of Routes' URIs. This function should be called from each specific
// project that defines routes.
func OptionsTestHelper(uris []string, routenames []string, t *testing.T) {

	for idx, uri := range uris {
		// Create a valid url. We look for routes containing {path:[a-zA-Z0-9=\\-\\_\\/\\.\\+]+},
		// and only keep the first part (ie. path)
		re := regexp.MustCompile("{([^/]+)?:.+?}")
		uri = re.ReplaceAllString(uri, "$1")
		body, ok := AssertRoute("OPTIONS", uri, http.StatusOK, t)
		t.Log("Detected uri:", uri)

		var parsed map[string]interface{}
		json.Unmarshal(*body, &parsed)
		assert.True(t, ok, "OPTIONS %s request failed", uri)
		assert.Equal(t, routenames[idx], parsed["name"],
			"OPTIONS %s request returned invalid name. Exp: [%s], got: [%s]", uri,
			routenames[idx], parsed["name"])
	}
}
